<?php
  header('Content-type: text/plain', true);

  include_once '../includes/globals.php';
  include_once '../includes/rosetta.class.php';

  // Check for ID result
  if (!file_exists(IDRESULT_PATH))
  {
    $outputArray = array(
      'name'  => 'Error',
      'value' => 'idResult missing');
    die(Rosetta::arrayToJSON($outputArray));
  }
  // Make ID result into a XMLDocument
  $xml = new XMLDocument(file_get_contents(IDRESULT_PATH));
  $xpath = xpath_new_context($xml->document_element());
  $categoryNodes = @ xpath_eval($xpath, '/diagOutput/category');
 
  $categories = array();
  $key = array(
    'name' => 'n',
    'caption' => 'c');
  $categories['key'] = $key;
  $categories['data'] = array();

  foreach($categoryNodes->nodeset as $category)
  {
    $categoryArray = array();
    $categoryArray[$key['name']] = $category->get_attribute('name');
    $categoryArray[$key['caption']] = $category->get_attribute('caption');
    $categories['data'][] = $categoryArray;
  }
 
  // Output JSON object
  exit(Rosetta::arrayToJSON($categories));
  //*/
?>
