function SaveLogDialog()
{
  inherit(this, new ModalElement(getElement('saveLogDialogPrompt')));
  this.header = extendElement(getElement('saveLogDialogPromptHeader'));
  this.currentConfigPrompt = extendElement(getElement('saveLogDialogPromptCurrentConfig'));
  this.currentConfigLabel = extendElement(getElement('saveLogDialogPromptCurrentConfigLabel'));
  this.allConfig = extendElement(getElement('saveLogDialogPromptAllConfig'));
  this.allConfigLabel = extendElement(getElement('saveLogDialogPromptAllConfigLabel'));
  this.cancelButton = extendElement(getElement('saveLogDialogPromptCancelButton'));
  this.okButton = extendElement(getElement('saveLogDialogPromptOkButton'));

  this.init();
}

SaveLogDialog.prototype.init = function init()
{
  this.cancelButton.controller = this;
  this.cancelButton.onclick = function ()
  {
    this.controller.hide();
  }

  this.okButton.controller = this;
  this.okButton.onclick = function ()
  {
    this.controller.saveOk(this.controller);
  }
}

SaveLogDialog.prototype.promptToSaveLog = function promptToSaveLog(title,configLabel,controller)
{
  this.title = title;
  this.header.innerHTML = title;
  this.controller = controller;
  this.header.innerHTML = title;
  this.currentConfigLabel.innerHTML = configLabel;
  this.allConfigLabel.innerHTML = translate('MSG_SAVE_ALL_LOGS');

  this.show();
}

SaveLogDialog.prototype.saveOk = function saveOk(controller)
{
  this.controller = controller;
  if( this.currentConfigLabel.innerHTML == translate('MSG_SAVE_DIAGNOSIS_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.diagnosisLog.saveAll();
    }
    else
    {
      Frontend.diagnosisLog.save();
    }
   }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_SAVE_ERROR_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.errorLog.saveAll();
    }
    else
    {
      Frontend.errorLog.save();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_SAVE_TEST_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.testLog.saveAll();
    }
    else
    {
      Frontend.testLog.save();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_SAVE_IML_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.imlLog.saveAll();
    }
    else
    {
      Frontend.imlLog.save();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_SAVE_SEL_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.selLog.saveAll();
    }
    else
    {
      Frontend.selLog.save();
    }
  }

  this.controller.hide();
}
